; 
;                               Build this project with MAKEIT.BAT
; 

    include \masm32\include\masm32rt.inc                    ; include the MASM32 runtime library

; --------------------------------------------------------------------------------------------------
;   If you are writing code for legacy hardware, comment out the following processor directives
; --------------------------------------------------------------------------------------------------

    .686p                                                   ; 686 privileged instructions
    .MMX                                                    ; multimedia extensions
    .XMM                                                    ; extended multimedia extensions

    include PrintMe.inc

; 

    .code                                                   ; start the code section of the application

start:                                                      ; the application entry point

    hInstance cgv(GetModuleHandle, NULL)                    ; create GLOBAL instance handle

    invoke DialogBoxParam,hInstance,1000,0,ADDR WndProc,0    ; Call the dialog box from the resource file

    invoke ExitProcess,eax                                  ; terminate the current running process

; 

WndProc proc hWin:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD

    LOCAL fname :DWORD
    LOCAL icce:INITCOMMONCONTROLSEX
    LOCAL hLib  :DWORD
    LOCAL print_text :DWORD
    LOCAL hMem  :DWORD

  ; --------------------------------------
  ; comment out the styles you don't need.
  ; --------------------------------------
    mov icce.dwSize, SIZEOF INITCOMMONCONTROLSEX            ; set the structure size
    xor eax, eax                                            ; set EAX to zero
    or eax, ICC_ANIMATE_CLASS                               ; OR as many styles as you need to it
    or eax, ICC_BAR_CLASSES                                 ; comment out the rest
    or eax, ICC_COOL_CLASSES
    or eax, ICC_DATE_CLASSES
    or eax, ICC_HOTKEY_CLASS
    or eax, ICC_INTERNET_CLASSES
    or eax, ICC_LISTVIEW_CLASSES
    or eax, ICC_PAGESCROLLER_CLASS
    or eax, ICC_PROGRESS_CLASS
    or eax, ICC_TAB_CLASSES
    or eax, ICC_TREEVIEW_CLASSES
    or eax, ICC_UPDOWN_CLASS
    or eax, ICC_USEREX_CLASSES
    or eax, ICC_WIN95_CLASSES
    mov icce.dwICC, eax
    invoke InitCommonControlsEx,ADDR icce                   ; initialise the common control library
  ; --------------------------------------

    switch uMsg
      case WM_INITDIALOG
        GLOBAL hWnd dd ?                                    ; create a GLOBAL handle for the main window
        m2m hWnd, hWin                                      ; Copy hWin to GLOBAL variable
        fn SendMessage,hWin,WM_SETTEXT,0,"Window Title"     ; overwrite dialog original if necessary
        invoke SendMessage,hWin,WM_SETICON,1,rv(LoadIcon,hInstance,1)

      ; --------------------------------------------------
      ; NOTE : cgv (create global value) is a MACRO that
      ; creates a GLOBAL scope value in the .DATA? section
      ; of this executable file. Do NOT create a LOCAL or
      ; GLOBAL value of the same name or you will get
      ; duplicate errors. Also note that each name must be
      ; unique top avoid duplicate errors.
      ; --------------------------------------------------
        hButton1 cgv(GetDlgItem,hWin,1001)
        lpButton1Proc cgv(SetWindowLong,hButton1,GWL_WNDPROC,Button1Proc)

        hButton2 cgv(GetDlgItem,hWin,1002)
        lpButton2Proc cgv(SetWindowLong,hButton2,GWL_WNDPROC,Button2Proc)

        hStatic1 cgv(GetDlgItem,hWin,1003)
        lpStatic1Proc cgv(SetWindowLong,hStatic1,GWL_WNDPROC,Static1Proc)

        hButton3 cgv(GetDlgItem,hWin,1004)
        lpButton3Proc cgv(SetWindowLong,hButton3,GWL_WNDPROC,Button3Proc)

        hButton4 cgv(GetDlgItem,hWin,1005)
        lpButton4Proc cgv(SetWindowLong,hButton4,GWL_WNDPROC,Button4Proc)

        return 1

      case WM_COMMAND
        switch wParam
          case 1001
           .data
             pattern db "All Files",0,"*.*",0,"Text Files",0,"*.txt",0,0
           .code

            mov fname, OpenFileDlg(hWnd,hInstance,"Open a New File",ADDR pattern)
            cmp BYTE PTR [eax], 0
            jne @F
            return 0
            @@:

            invoke SetWindowText,hStatic1,fname

            mov hLib, rv(LoadLibrary,"printtxt.dll")                    ; dynamic load the DLL
            test eax, eax
            jz nolib
            mov print_text, rv(GetProcAddress,hLib,"print_text")        ; get the printer proc address
            test eax, eax
            jz noproc

            mov hMem, InputFile(fname)

            push hWnd
            push hMem
            call print_text

            invoke FreeLibrary,hLib
            free hMem
            return 0

          nolib:
            fn MessageBox,hWin,"Ensure PRINTTXT.DLL is in this directory before trying to call it","Howdy",MB_OK
            return 0

          noproc:
            fn MessageBox,hWin,"Ensure PRINTTXT.DLL is in this directory before trying to call it","Whoops",MB_OK
            return 0

          case 1004     ; Button3
            fn MessageBox,hWin,"Print File Demo In MASM32","Howdy",MB_OK

          case 1005
            jmp exit_dialog

        endsw

      case WM_PAINT
        invoke paint_proc,hWin
        return 0

      case WM_CLOSE
        exit_dialog:                                        ; jump to this label to close program
        invoke EndDialog,hWin,0

    endsw

    return 0

WndProc endp

; 

paint_proc proc hWin:DWORD

    LOCAL hDC:DWORD
    LOCAL Ps :PAINTSTRUCT

    mov hDC, rv(BeginPaint,hWin,ADDR Ps)                    ; get the device context handle
  ; --------------------------------------

  ; Write your GDI graphics code here

  ; --------------------------------------
    invoke EndPaint,hWin,ADDR Ps

    ret

paint_proc endp

; 

    include subclass.asm

end start                                                   ; tell MASM where the application end is.

