; 
    include \masm32\include\masm32rt.inc
; 

    print_text   PROTO :DWORD,:DWORD
    preview_win  PROTO :DWORD
    preview_proc PROTO :DWORD,:DWORD,:DWORD,:DWORD
    edit_print   PROTO :DWORD,:DWORD,:DWORD
    RegisterWinClass PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD
    PushButton   PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD
    RichEdit2    PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD
    reProc       PROTO :DWORD,:DWORD,:DWORD,:DWORD
    TopXY        PROTO :DWORD,:DWORD
    charfill     PROTO :DWORD,:DWORD,:DWORD
    GetFontDialog PROTO :DWORD,:DWORD,:DWORD,:DWORD
    cbFontDlg    PROTO :DWORD,:DWORD,:DWORD,:DWORD
    get_app_path PROTO :DWORD
    charfill     PROTO :DWORD,:DWORD,:DWORD
    shadowwin    PROTO :DWORD
    shadow_proc  PROTO :DWORD,:DWORD,:DWORD,:DWORD

  AutoScale MACRO swidth, sheight
    invoke GetPercent,sWid,swidth
    mov Wwd, eax
    invoke GetPercent,sHgt,sheight
    mov Wht, eax

    invoke TopXY,Wwd,sWid
    mov Wtx, eax

    invoke TopXY,Wht,sHgt
    mov Wty, eax
  ENDM

  .data?
    prInstance dd ?
    prWnd      dd ?
    prEdit     dd ?
    sWid       dd ?
    sHgt       dd ?
    prIcon     dd ?
    hCursor    dd ?
    prFont     dd ?
    prTxt      dd ?
    pvWnd      dd ?
    wRight     dd ?
    wBottom    dd ?
    prct       RECT <?>

    filenamebuf db 260 dup (?)
    bufferfont1 db 32  dup (?)
    bufrheight1 db 16  dup (?)
    bufrweight1 db 16  dup (?)
    bufritalic1 db 16  dup (?)

  .data
    printfontini dd filenamebuf         ; settings filename pointer
    fontfacename dd bufferfont1         ; font face name buffer pointer
    prfontheight dd bufrheight1         ; font height buffer pointer
    prfontweight dd bufrweight1         ; font weight buffer pointer
    prfontitalic dd bufritalic1         ; font italic setting pointer

    .code

; 

LibMain proc instance:DWORD,reason:DWORD,unused:DWORD 

    .if reason == DLL_PROCESS_ATTACH
      mrm prInstance, instance          ; copy local to global
      mov eax, TRUE                     ; return TRUE so DLL will start
    .endif

    ret

LibMain endp

; 

print_text proc lprTxt:DWORD,hParent:DWORD

    fn LoadLibrary,"RICHED20.DLL"

    mrm prWnd,hParent                   ; copy parent address to global
    mrm prTxt,lprTxt                    ; copy text address to global

    invoke preview_win,prWnd

    ret

print_text endp

; 

preview_win proc parent:DWORD

    LOCAL Wwd:DWORD,Wht:DWORD,Wtx:DWORD,Wty:DWORD
    LOCAL pClassName    :DWORD
    LOCAL msg           :MSG

    mov prIcon,     rv(LoadIcon,NULL,IDI_APPLICATION)
    mov hCursor,    rv(LoadCursor,NULL,IDC_ARROW)

    mov sWid,       rv(GetSystemMetrics,SM_CXSCREEN)
    mov sHgt,       rv(GetSystemMetrics,SM_CYSCREEN)

    sas pClassName,"print_preview_class"

    invoke RegisterWinClass,ADDR preview_proc,pClassName,
                            prIcon,hCursor,COLOR_WINDOW+1

    AutoScale 50, 90

    fn CreateWindowEx,WS_EX_LEFT or WS_EX_ACCEPTFILES, \
                      pClassName, \
                      "Print Preview --- Navigate --- PgUp PgDn Arrow Keys", \
                      WS_OVERLAPPEDWINDOW, \
                      Wtx,Wty,Wwd,Wht, \
                      parent,NULL, \
                      prInstance,NULL
    mov pvWnd,eax

    invoke ShowWindow,pvWnd,SW_SHOW
    invoke UpdateWindow,pvWnd

  StartLoop:

    switch msg.message
      case WM_SYSKEYDOWN
        switch msg.wParam
          case VK_P
            invoke SendMessage,pvWnd,WM_COMMAND,100,0       ; print text
          case VK_F
            invoke SendMessage,pvWnd,WM_COMMAND,102,0       ; set font
          case VK_C
            invoke SendMessage,pvWnd,WM_COMMAND,101,0       ; close DLL
        endsw
      case WM_KEYDOWN
        switch msg.wParam
          case VK_ESCAPE
            invoke SendMessage,pvWnd,WM_COMMAND,101,0
        endsw

    endsw

    invoke TranslateMessage, ADDR msg
    invoke DispatchMessage,  ADDR msg
  nextmsg:
    invoke GetMessage,ADDR msg,NULL,0,0
    test eax, eax
    jne StartLoop

    ret

preview_win endp

; 

RegisterWinClass proc lpWndProc:DWORD, lpClassName:DWORD,
                      Icon:DWORD, Cursor:DWORD, bColor:DWORD

    LOCAL wc:WNDCLASSEX

    mov wc.cbSize,         sizeof WNDCLASSEX
    mov wc.style,          CS_BYTEALIGNCLIENT or \
                           CS_BYTEALIGNWINDOW
    m2m wc.lpfnWndProc,    lpWndProc
    mov wc.cbClsExtra,     NULL
    mov wc.cbWndExtra,     NULL
    m2m wc.hInstance,      prInstance
    m2m wc.hbrBackground,  bColor
    mov wc.lpszMenuName,   NULL
    m2m wc.lpszClassName,  lpClassName
    m2m wc.hIcon,          Icon
    m2m wc.hCursor,        Cursor
    m2m wc.hIconSm,        Icon

    invoke RegisterClassEx, ADDR wc

    ret

RegisterWinClass endp

; 

preview_proc proc hWin:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD

    LOCAL hDC   :DWORD
    LOCAL pDC   :DWORD
    LOCAL rct   :RECT
    LOCAL cr    :CHARRANGE
    LOCAL tlen  :DWORD
    LOCAL pmem  :DWORD
    LOCAL pd    :PRINTDLG
    LOCAL lf    :LOGFONT
    LOCAL cfm2  :CHARFORMAT2
    LOCAL pWid  :DWORD
    LOCAL pHgt  :DWORD
    LOCAL ital  :DWORD

    LOCAL wTwip  :DWORD
    LOCAL hTwip  :DWORD
    LOCAL hRes   :DWORD
    LOCAL vRes   :DWORD
    LOCAL hppli  :DWORD
    LOCAL vppli  :DWORD
    LOCAL fhgt   :DWORD
    LOCAL fwgt   :DWORD
    LOCAL ps    :PAINTSTRUCT

    switch uMsg

      case WM_SETFOCUS
        invoke SetFocus,prEdit



      case WM_COMMAND           ; ==============================================================
        switch wParam
          case 100
            invoke edit_print,hWin,prEdit,prInstance
          case 101
            invoke SendMessage,hWin,WM_SYSCOMMAND,SC_CLOSE,0
          case 102
            invoke charfill,ADDR lf,SIZEOF lf,0

            fn szCopy,fontfacename,ADDR lf.lfFaceName
            m2m lf.lfHeight, sval(prfontheight)
            m2m lf.lfWeight, sval(prfontweight)

            mov eax, sval(prfontitalic)
            mov lf.lfItalic, al

            invoke GetFontDialog,hWin,ADDR lf,CF_BOTH or \
                                 CF_NOSCRIPTSEL or CF_ENABLEHOOK or \
                                 CF_FORCEFONTEXIST or CF_INITTOLOGFONTSTRUCT, 0
            test eax, eax
            jz nofontchange

            invoke DeleteObject,prFont

            movzx edx, BYTE PTR lf.lfItalic
            mov ital, edx

            fn CreateFont,lf.lfHeight,0,0,0,lf.lfWeight,ital,0,0, \
                   DEFAULT_CHARSET,OUT_DEFAULT_PRECIS, \
                   CLIP_DEFAULT_PRECIS,PROOF_QUALITY, \
                   DEFAULT_PITCH,ADDR lf.lfFaceName
            mov prFont, eax

            invoke SendMessage,prEdit,WM_SETFONT,prFont,TRUE

            fn szCopy,ADDR lf.lfFaceName,fontfacename
            neg lf.lfHeight
            fn szCopy,str$(lf.lfHeight),prfontheight
            fn szCopy,str$(lf.lfWeight),prfontweight
            movzx eax, BYTE PTR lf.lfItalic
            fn szCopy,str$(eax),prfontitalic

            call write_txt_ini

            invoke charfill,ADDR pd,SIZEOF PRINTDLG,0
    
            mov pd.lStructSize, SIZEOF pd
            mrm pd.hwndOwner,   hWin
            mov pd.Flags,       PD_RETURNDC or PD_RETURNDEFAULT     ; just get information
            mrm pd.hInstance,   prInstance
    
            invoke PrintDlg,ADDR pd
    
            mov hRes, rv(GetDeviceCaps,pd.hDC,HORZRES)              ; horizontal resolution
            mov hppli, rv(GetDeviceCaps,pd.hDC,LOGPIXELSX)          ; horizontal pixels per logical inch
    
            mov esi, rv(IntDiv,hRes,hppli)
            mov wTwip, rv(IntMul,esi,1440)                          ; calculate width
    
            sub wTwip, 1440
    
            invoke SendMessage,prEdit,EM_SETTARGETDEVICE,pd.hDC,wTwip
    
            invoke DeleteDC,pd.hDC

          nofontchange:

        endsw

      case WM_CREATE           ; ==============================================================
        fn PushButton,"&Print",hWin,10,10,80,22,100
        fn PushButton,"&Font", hWin,100,10,80,22,102
        fn PushButton,"&Close",hWin,190,10,80,22,101

        mov prEdit, rv(RichEdit2,50,50,800,500,hWin,prInstance,500,1)

        mov wRight, rv(shadowwin,hWin)
        mov wBottom, rv(shadowwin,hWin)

        invoke SendMessage,prEdit,EM_SETOPTIONS,ECOOP_XOR,ECO_SELECTIONBAR
        invoke SendMessage,prEdit,EM_EXLIMITTEXT,0,1000000000

        invoke get_app_path,printfontini
        mov printfontini, cat$(printfontini,"prfont.bin")
    
        .if rv(exist,printfontini)
          call read_txt_ini
        .else
          push esi
          mov esi, fcreate(printfontini)
          fprint esi, "courier new"
          fprint esi, "14"
          fprint esi, "500"
          fprint esi, "0"
          fclose esi
          pop esi
          call read_txt_ini
        .endif

        mov fhgt, sval(prfontheight)
        mov fwgt, sval(prfontweight)
        mov ital, sval(prfontitalic)

        fn CreateFont,fhgt,0,0,0,fwgt,ital,0,0, \
               DEFAULT_CHARSET,OUT_DEFAULT_PRECIS, \
               CLIP_DEFAULT_PRECIS,PROOF_QUALITY, \
               DEFAULT_PITCH,fontfacename
        mov prFont, eax

        invoke SendMessage,prEdit,EM_SETMARGINS,EC_LEFTMARGIN or EC_RIGHTMARGIN,00200020h
        invoke SendMessage,prEdit,EM_SETBKGNDCOLOR,0,00FFFFFFh
        invoke SendMessage,prEdit,WM_SETFONT,prFont,TRUE

      ; ----------------------------------------

        invoke charfill,ADDR pd,SIZEOF PRINTDLG,0

        mov pd.lStructSize, SIZEOF pd
        mrm pd.hwndOwner,   hWin
        mov pd.Flags,       PD_RETURNDC or PD_RETURNDEFAULT     ; just get information
        mrm pd.hInstance,   prInstance

        invoke PrintDlg,ADDR pd

        mov hRes, rv(GetDeviceCaps,pd.hDC,HORZRES)              ; horizontal resolution
        mov hppli, rv(GetDeviceCaps,pd.hDC,LOGPIXELSX)          ; horizontal pixels per logical inch

        mov esi, rv(IntDiv,hRes,hppli)
        mov wTwip, rv(IntMul,esi,1440)                          ; calculate width

        sub wTwip, 1440

        invoke SendMessage,prEdit,EM_SETTARGETDEVICE,pd.hDC,wTwip

        invoke DeleteDC,pd.hDC

        invoke charfill,ADDR cfm2,SIZEOF CHARFORMAT2,0


        mov cfm2.cbSize,            SIZEOF CHARFORMAT2
        mov cfm2.dwMask,            CFM_SIZE
        mov cfm2.dwEffects,         0

        mov eax, rv(IntMul,fhgt,15)                     ; mul dlg font height by 15 for twips

        mov cfm2.yHeight,           eax                 ; <<<< twips

        invoke SendMessage,prEdit,EM_SETCHARFORMAT,SCF_ALL,ADDR cfm2

        .if len(prTxt) == 0
          fn SetWindowText,hWin,"No Text To Print"
          invoke GetDlgItem,hWin,100
          invoke EnableWindow,eax,FALSE                         ; disable print button
          jmp notxt
        .endif

        invoke SetWindowText,prEdit,prTxt

        invoke GetClientRect,prEdit,ADDR prct

      notxt:

      case WM_SIZE           ; ==============================================================
        push esi
        push edi
        mov esi, 50
        invoke GetClientRect,hWin,ADDR rct

        mov eax, rct.right
        sub eax, prct.right

        .if SDWORD PTR eax < 10
          jmp past
        .endif

        shr eax, 1
        mov edi, eax

        sub rct.bottom, esi
        sub rct.bottom, 25

        invoke MoveWindow,prEdit,edi,esi,prct.right,rct.bottom,TRUE

      past:

        ; wRight
        ; wBottom

        mov eax, edi
        add eax, prct.right

        invoke GetWindowRect,prEdit,ADDR rct
        invoke ScreenToClient,hWin,ADDR rct.left
        invoke ScreenToClient,hWin,ADDR rct.right

        mov esi, rct.bottom
        sub esi, rct.top
        add rct.top, 6
        add rct.bottom, 6
        invoke MoveWindow,wRight,rct.right,rct.top,6,esi,TRUE

        invoke GetWindowRect,prEdit,ADDR rct
        invoke ScreenToClient,hWin,ADDR rct.left
        invoke ScreenToClient,hWin,ADDR rct.right

        add rct.left, 6
        mov esi, rct.right
        sub esi, rct.left
        invoke MoveWindow,wBottom,rct.left,rct.bottom,esi,6,TRUE


        pop edi
        pop esi

      case WM_CLOSE
        invoke DeleteObject,prFont
        .if prWnd != 0
          invoke SetActiveWindow,prWnd
        .endif

      case WM_DESTROY
        invoke PostQuitMessage,NULL
        return 0

    endsw

    invoke DefWindowProc,hWin,uMsg,wParam,lParam

    ret

preview_proc endp

; 

edit_print proc parent:DWORD,edit:DWORD,instance:DWORD

    LOCAL wTwip         :DWORD
    LOCAL hTwip         :DWORD
    LOCAL mLeft         :DWORD
    LOCAL mTop          :DWORD
    LOCAL mRight        :DWORD
    LOCAL mBottom       :DWORD
    LOCAL szPrint       :DWORD
    LOCAL hRes          :DWORD
    LOCAL vRes          :DWORD
    LOCAL hppli         :DWORD
    LOCAL vppli         :DWORD
    LOCAL pd            :PRINTDLG
    LOCAL fr            :FORMATRANGE
    LOCAL dinf          :DOCINFO
    LOCAL cr            :CHARRANGE
    LOCAL pbuf          :DWORD
    LOCAL buffer[64]    :BYTE

    push ebx
    push esi
    push edi

    sas szPrint,"Print"

    invoke SendMessage,edit,EM_FORMATRANGE,FALSE,NULL

  ; ------------------------
  ; zero fill the structures
  ; ------------------------
    invoke charfill,ADDR pd,SIZEOF PRINTDLG,0
    invoke charfill,ADDR fr,SIZEOF FORMATRANGE,0
    invoke charfill,ADDR dinf,SIZEOF DOCINFO,0

    mov pd.lStructSize, SIZEOF pd
    mrm pd.hwndOwner,   parent
    mov pd.Flags,       PD_RETURNDC or PD_NOPAGENUMS or PD_PRINTSETUP
    mrm pd.hInstance,   instance

  ; ------------------
  ; half inch in TWIPS
  ; ------------------
    mov mLeft,      720         ; left   margin
    mov mTop,       720         ; top    margin
    mov mRight,     720         ; right  margin
    mov mBottom,    720         ; bottom margin

    ; -----------------------------------------------

    .if rv(PrintDlg,ADDR pd)
      invoke SetCursor,rv(LoadCursor,NULL,IDC_WAIT)

      mov hRes, rv(GetDeviceCaps,pd.hDC,HORZRES)            ; horizontal resolution
      mov vRes, rv(GetDeviceCaps,pd.hDC,VERTRES)            ; vertical resolution

      mov hppli, rv(GetDeviceCaps,pd.hDC,LOGPIXELSX)        ; horizontal pixels per logical inch
      mov vppli, rv(GetDeviceCaps,pd.hDC,LOGPIXELSY)        ; vertical pixels per logical inch

      mov esi, rv(IntDiv,hRes,hppli)
      mov wTwip, rv(IntMul,esi,1440)                        ; calculate width

      mov esi, rv(IntDiv,vRes,vppli)
      mov hTwip, rv(IntMul,esi,1440)                        ; calculate height

      mrm fr.hdc,           pd.hDC
      mrm fr.hdcTarget,     pd.hDC

      mrm fr.rcPage.left, mLeft
      mrm fr.rcPage.top, mTop

      mrm fr.rcPage.right, wTwip
      mov eax, mRight
      sub fr.rcPage.right, eax

      mrm fr.rcPage.bottom, hTwip
      mov eax, mBottom
      sub fr.rcPage.bottom, eax

      mrm fr.rc.left, mLeft
      mrm fr.rc.top, mTop
      mrm fr.rc.right, fr.rcPage.right
      mrm fr.rc.bottom, fr.rcPage.bottom

    ; ------------------------
    ; whole document selection
    ; ------------------------
      mov fr.chrg.cpMin, 0
      mov fr.chrg.cpMax, -1
      invoke SendMessage,edit,EM_EXSETSEL,0,ADDR fr.chrg    ; select whole document
      invoke SendMessage,edit,EM_EXGETSEL,0,ADDR fr.chrg    ; get the actual cpMax value

    ; -----------------------------------------------

      mov dinf.cbSize,      SIZEOF dinf
      mrm dinf.lpszDocName, szPrint
      mov dinf.lpszOutput,  NULL

      invoke StartDoc,pd.hDC,ADDR dinf

  ; ******************************

    mov ebx, 1                                              ; set the page counter

    print_loop:
      mov pbuf, ptr$(buffer)
      invoke SetWindowText,pvWnd,cat$(pbuf,"Printing Page ",str$(ebx))
      add ebx, 1
      invoke StartPage,pd.hDC
      mov esi, rv(SendMessage,edit,EM_FORMATRANGE,TRUE,ADDR fr)
      cmp esi, fr.chrg.cpMax
      jge outp
      mov fr.chrg.cpMin,esi
      invoke EndPage,pd.hDC
      jmp print_loop
    outp:

  ; ******************************

      invoke SendMessage,edit,EM_FORMATRANGE,FALSE,NULL
      invoke EndPage, pd.hDC
      invoke EndDoc,  pd.hDC
      invoke DeleteDC,pd.hDC

      invoke SetCursor,rv(LoadCursor,NULL,IDC_ARROW)

      mov eax, 1
    .endif

    ; -----------------------------------------------

    pop edi
    pop esi
    pop ebx

    ret

edit_print endp

; 

GetFontDialog proc hWin:DWORD,pLogFont:DWORD,fStyle:DWORD,swtch:DWORD

  ; ---------------------------------
  ; hWin     = parent handle
  ; pLogFont = ADDR LOGFONT structure
  ; fstyle   = font listing style flags
  ; styles are ORRed for required results
  ; Font flags are found in the CHOOSEFONT
  ; reference.
  ;
  ; swtch is passed as a flag to the hook procedure
  ; for selecting the correct title for the font dialog
  ;
  ; If eax returns zero, cancel was
  ; pressed. If selection is made,
  ; return in eax is non zero and
  ; LOGFONT structure is filled
  ; with font information.
  ; ---------------------------------

    LOCAL hDC   :DWORD
    LOCAL cf    :CHOOSEFONT

    invoke GetDC,hWin
    mov hDC, eax

    mov cf.lStructSize,     sizeof CHOOSEFONT
    m2m cf.hWndOwner,       hWin
    m2m cf.hDC,             hDC
    m2m cf.lpLogFont,       pLogFont
    mov cf.iPointSize,      0
    m2m cf.Flags,           fStyle              ; font listing style flags
    mov cf.rgbColors,       0
    m2m cf.lCustData,       0           ; swtch               ; value passed to hook procedure
    mov cf.lpfnHook,        OFFSET cbFontDlg
    mov cf.lpTemplateName,  0
    mov cf.hInstance,       0
    mov cf.lpszStyle,       0
    mov cf.nFontType,       0
    mov cf.Alignment,       0
    mov cf.nSizeMin,        0
    mov cf.nSizeMax,        0

    invoke ChooseFont,ADDR cf
    push eax
    invoke ReleaseDC,hWin,hDC
    pop eax

    ret

GetFontDialog endp

; 

cbFontDlg proc hWin:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD

    switch uMsg
      case WM_INITDIALOG
        mov eax, lParam
        mov eax, (CHOOSEFONT PTR [eax]).lCustData
        fn SetWindowText,hWin,"Select the font for your document"
    endsw

    xor eax, eax
    ret

cbFontDlg endp

; 

read_txt_ini proc

    LOCAL hFile :DWORD
    LOCAL flen  :DWORD
    LOCAL pINI  :DWORD
    LOCAL ptok  :DWORD
    LOCAL bred  :DWORD
    LOCAL lcnt  :DWORD
    LOCAL parr  :DWORD
    LOCAL cntt  :DWORD

    push ebx
    push esi
    push edi

    mov hFile, fopen(printfontini)
    mov flen, fsize(hFile)
    mov pINI, alloc(flen)
    mov bred, fread(hFile,pINI,flen)
    mov cntt, rv(ltok,pINI,ADDR parr)
    mov esi, parr
    fn szCopy,[esi],    fontfacename
    fn szCopy,[esi+4],  prfontheight
    fn szCopy,[esi+8],  prfontweight
    fn szCopy,[esi+12], prfontitalic

    free parr
    free pINI
    fclose hFile

    pop edi
    pop esi
    pop ebx

    ret

read_txt_ini endp

; 

write_txt_ini proc

    push esi
    mov esi, fcreate(printfontini)
    fprint esi, fontfacename
    fprint esi, prfontheight
    fprint esi, prfontweight
    fprint esi, prfontitalic
    fclose esi
    pop esi

    ret

write_txt_ini endp

; 

get_app_path proc hMem:DWORD

    LOCAL pbuf  :DWORD
    LOCAL buffer[260]:BYTE

    mov pbuf, ptr$(buffer)

    invoke GetModuleFileName,NULL,pbuf,260
    invoke GetPathOnly,pbuf,hMem

    mov eax, hMem

    ret

get_app_path endp

; 

OPTION PROLOGUE:NONE 
OPTION EPILOGUE:NONE 

TopXY proc wDim:DWORD, sDim:DWORD

    mov eax, [esp+8]
    sub eax, [esp+4]
    shr eax, 1

    ret 8

TopXY endp

OPTION PROLOGUE:PrologueDef 
OPTION EPILOGUE:EpilogueDef 

; 

PushButton proc lpText:DWORD,hParent:DWORD,
                a:DWORD,b:DWORD,wd:DWORD,ht:DWORD,ID:DWORD

    fn CreateWindowEx,0,"BUTTON",lpText, \
                         WS_CHILD or WS_VISIBLE or BS_FLAT, \
                         a,b,wd,ht,hParent,ID,prInstance,NULL
    ret

PushButton endp

; 

RichEdit2 proc a:DWORD,b:DWORD,wd:DWORD,ht:DWORD,
               hParent:DWORD,instance:DWORD,ID:DWORD,WRAP:DWORD

    LOCAL wStyle :DWORD
    LOCAL hndl   :DWORD

    mov wStyle, WS_VISIBLE or WS_CHILDWINDOW or ES_MULTILINE or \
                ES_AUTOVSCROLL or ES_AUTOHSCROLL        ; ES_NOHIDESEL or ES_DISABLENOSCROLL or 

    fn CreateWindowEx,WS_EX_LEFT,"RichEdit20a",0,wStyle, \
                          a,b,wd,ht,hParent,ID,instance,NULL

    ret

RichEdit2 endp

; 

OPTION PROLOGUE:NONE 
OPTION EPILOGUE:NONE 

    align 16

charfill proc buff:DWORD,bcnt:DWORD,char:DWORD

    mov ecx, [esp+4]        ; data address
    mov edx, [esp+8]        ; fill count
    mov eax, [esp+12]       ; fill character
    sub ecx, 1

  @@:
    add ecx, 1
    mov [ecx], al
    sub edx, 1
    jnz @B

    ret 12

charfill endp

OPTION PROLOGUE:PrologueDef 
OPTION EPILOGUE:EpilogueDef 

; 

shadowwin proc parent:DWORD

    LOCAL hndl  :DWORD
    LOCAL swClassName   :DWORD
    LOCAL wc:WNDCLASSEX

    sas swClassName,"shadow_class"

    mov wc.cbSize,         sizeof WNDCLASSEX
    mov wc.style,          CS_VREDRAW or \
                           CS_HREDRAW
    m2m wc.lpfnWndProc,    OFFSET shadow_proc
    mov wc.cbClsExtra,     NULL
    mov wc.cbWndExtra,     NULL
    m2m wc.hInstance,      prInstance
    m2m wc.hbrBackground,  rv(GetStockObject,DKGRAY_BRUSH)
    mov wc.lpszMenuName,   NULL
    m2m wc.lpszClassName,  swClassName
    m2m wc.hIcon,          prIcon
    m2m wc.hCursor,        hCursor
    m2m wc.hIconSm,        prIcon

    invoke RegisterClassEx, ADDR wc

    fn CreateWindowEx,WS_EX_LEFT or WS_EX_ACCEPTFILES, \
                          swClassName, \
                          "Print Preview", \
                          WS_CHILD  or WS_CLIPSIBLINGS, \
                          10,10,100,100, \
                          parent,NULL, \
                          prInstance,NULL
    mov hndl,eax

    invoke ShowWindow,hndl,SW_SHOW
    invoke UpdateWindow,hndl

    mov eax, hndl

    ret

shadowwin endp

; 

shadow_proc proc hWin:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD

    invoke DefWindowProc,hWin,uMsg,wParam,lParam

    ret

shadow_proc endp

; 
















end LibMain
